package cn.dankal.share.common;

import java.util.concurrent.TimeUnit;

/**
 * int 数组 求和工具类
 *
 * @author ZGH.MercyModest
 * @version V1.0.0
 * @create 2021-01-02
 */
public class IntArraySumUtil {

    /**
     * 数组求和
     *
     * @param targetArray 目标数组
     * @param fromIndex   from index
     * @param toIndex     to  index
     * @return 计算结果
     */
    public static int sumArray(int[] targetArray, int fromIndex, int toIndex) {
        if (toIndex < fromIndex) {
            throw new IllegalArgumentException("fromIndex 必须小于等于 toIndex");
        }
        if (targetArray.length <= toIndex) {
            throw new IllegalArgumentException("toIndex 超出 数组长度范围");
        }
        int result = 0;
        for (int i = fromIndex; i <= toIndex; i++) {
            try {
                // TODO 休眠 100 毫秒 便于区分不同计算方式和 fork/join 的区别
                TimeUnit.MILLISECONDS.sleep(100);
            } catch (InterruptedException e) {
                // ignore
            }
            result += targetArray[i];
        }
        return result;
    }
}
